#include "tpa_functions.h"

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void InitCommonControlsEx();

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
	WNDCLASSEX wc; 
	MSG Msg; 
	
     char Path[MAX_PATH];
     
     GetModuleFileName(NULL, Path, MAX_PATH);
     getDrivePath=Path;
     int truncate_path = getDrivePath.find_last_of("\\");
     getDrivePath.erase(truncate_path+1);   /* Retain full pathway  */	
     temp_eelFile=getDrivePath;
     temp_wavdata=getDrivePath;
     exp_crcValues=getDrivePath;
     holdpathway=getDrivePath;
     temp_capdata=getDrivePath;
        
     temp_eelFile+="\\exp_caus\\new_eel.eel";
     temp_wavdata+="raw_audio.raw";
     exp_crcValues+="SndIds.dat";
     holdpathway+="\\caus_out\\";
     temp_capdata+="temp_captions.dat";

	memset(&wc,0,sizeof(wc));
	wc.cbSize		 = sizeof(WNDCLASSEX);
	wc.lpfnWndProc	 = WndProc; 
	wc.hInstance	 = hInstance;
	wc.hCursor		 = LoadCursor(NULL, IDC_ARROW);
	
	wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
	wc.lpszClassName = "Caption_Editor";
	wc.hIcon		 = LoadIcon(NULL, IDI_APPLICATION); 
	wc.hIconSm		 = LoadIcon(NULL, IDI_APPLICATION); 

	if(!RegisterClassEx(&wc)) {
		MessageBox(NULL, "Window Registration Failed!","Error!",MB_ICONEXCLAMATION|MB_OK);
		return 0;
	}
	
    hwnd = CreateWindowEx (
           0, 
           "Caption_Editor",
           "Caption_Editor",
           WS_OVERLAPPEDWINDOW&~WS_MAXIMIZEBOX&~WS_THICKFRAME,
	   	   CW_USEDEFAULT, 
		   CW_USEDEFAULT,
		   640, 
		   480,
           NULL,
           NULL,
           hInstance, 
           NULL 
           );	
           
    ShowWindow (hwnd, nCmdShow); 
	
    hOldCaptions = CreateWindowEx(WS_EX_CLIENTEDGE, TEXT("EDIT"), TEXT(""),
    WS_CHILD | WS_VISIBLE | WS_VSCROLL | ES_READONLY | ES_MULTILINE ,
    9, 30, 375, 140, hwnd,
    (HMENU) IDE_OLDCAPS, GetModuleHandle(NULL), NULL);

    SendMessage(hOldCaptions, WM_SETFONT, (WPARAM) GetStockObject(DEFAULT_GUI_FONT),
    true); 
	
    hNewCaptions = CreateWindowEx(WS_EX_CLIENTEDGE, TEXT("EDIT"), TEXT(""),
    WS_CHILD | WS_VISIBLE |ES_MULTILINE| WS_VSCROLL |ES_AUTOVSCROLL,
    9, 220, 375, 140, hwnd,
    (HMENU) IDE_NEWCAPS, GetModuleHandle(NULL), NULL);
    

    SendMessage(hNewCaptions, WM_SETFONT, (WPARAM) GetStockObject(DEFAULT_GUI_FONT),
    true);
    
    EnableWindow(hNewCaptions, false);
	
    hForward = CreateWindowEx(0,TEXT("BUTTON"),TEXT("View Next Entry"),                      
    WS_CHILD| WS_VISIBLE | BS_PUSHBUTTON,
    134, 180, 120, 24,              
    hwnd, (HMENU) IDB_FORWARD, GetModuleHandle(NULL),NULL);
    
    SendMessage(hForward, WM_SETFONT, (WPARAM) GetStockObject(DEFAULT_GUI_FONT),
    true);
	    
    hDone = CreateWindowEx(0,TEXT("BUTTON"),TEXT("DONE"),                      
    WS_CHILD| WS_VISIBLE | BS_PUSHBUTTON,
    480, 380, 60, 24,              
    hwnd, (HMENU) IDB_DONE, GetModuleHandle(NULL),NULL);	
	
    SendMessage(hDone, WM_SETFONT, (WPARAM) GetStockObject(DEFAULT_GUI_FONT),
    true);	
	
    hExports = CreateWindowEx(0,TEXT("BUTTON"),TEXT("Save New Captions"),                      
    WS_CHILD| WS_VISIBLE | BS_PUSHBUTTON,
    134, 380, 120, 24,              
    hwnd, (HMENU) IDB_EXPORTS, GetModuleHandle(NULL),NULL);	
	
    SendMessage(hExports, WM_SETFONT, (WPARAM) GetStockObject(DEFAULT_GUI_FONT),
    true);	
    
    hNumsEdit = CreateWindowEx(WS_EX_CLIENTEDGE, TEXT("EDIT"), TEXT("0"),                     
    WS_CHILD| WS_VISIBLE | ES_NUMBER , 417, 340, 40, 20,              
    hwnd, (HMENU) IDE_NUMBERS, GetModuleHandle(NULL),NULL);
    SendMessage(hNumsEdit, WM_SETFONT, (WPARAM) GetStockObject(DEFAULT_GUI_FONT), true);    
    
    hSetIndex = CreateWindowEx(0,TEXT("BUTTON"),TEXT("Reset Entry No#"),                      
    WS_CHILD| WS_VISIBLE | BS_PUSHBUTTON,
    480, 340, 110, 22,              
    hwnd, (HMENU) IDB_INDEX, GetModuleHandle(NULL),NULL);	
	
    SendMessage(hSetIndex, WM_SETFONT, (WPARAM) GetStockObject(DEFAULT_GUI_FONT),
    true);	    
	
       HDC hDC=NULL, hDC_player=NULL;
       HBITMAP p_player;
       int nWidth, nHeight;


	hUserInfo=CreateWindowEx(0, TEXT("STATIC"), TEXT(""),   
	WS_VISIBLE | WS_CHILD | SS_BITMAP, 410,32,199,297,
	hwnd,(HMENU) IDS_USERS,GetModuleHandle(NULL),NULL);

    //Skin static control for information usage
       p_player = reinterpret_cast<HBITMAP>(LoadImage(GetModuleHandle (NULL),
       MAKEINTRESOURCE(IDI_INFO),
       IMAGE_BITMAP,0,0,
       LR_CREATEDIBSECTION));
       
       SendMessage(hUserInfo,(UINT)STM_SETIMAGE,
       (WPARAM)IMAGE_BITMAP,(LPARAM)p_player);
       
       HDC memDC_ply = CreateCompatibleDC ( hDC_player );
       p_player = CreateCompatibleBitmap (hDC_player, nWidth, nHeight);
       
       SelectObject ( memDC_ply, p_player ); 
       DeleteDC(memDC_ply);
       DeleteObject(p_player);				  	        

	if(hwnd == NULL) {
		MessageBox(NULL, "Window Creation Failed!","Error!",MB_ICONEXCLAMATION|MB_OK);
		return 0;
	}

	while(GetMessage(&Msg, NULL, 0, 0) > 0) { /* If no error is received... */
		TranslateMessage(&Msg); /* Translate key codes to chars if present */
		DispatchMessage(&Msg); /* Send it to WndProc */
	}
	return Msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam) {
	switch(Message) {
		
		case WM_CREATE:
		 {
		  AppendMenu(hMenuBar, MF_POPUP, (UINT_PTR) hFile, "File");   
	      AppendMenu(hFile, MF_STRING, MU_LOADTPA, "Load_Tpa");	
	      SetMenu(hwnd, hMenuBar); 
		  break;
		 }
		
		case WM_DESTROY: {
		   if(fileLoaded==1 && wavCount>1)
		    {
		     DeleteFile(temp_wavdata.c_str());
		    }
			PostQuitMessage(0);
			break;
		}

        case WM_COMMAND:
            {
            	
          switch(LOWORD(wParam))
           { 
         
		    case IDB_INDEX:
             {
              if(fileLoaded==1){
              char* size_buffer;
              short TempNumber;

              std::string pidword;
              std::string pidsize;
              std::string swpfile;

              BOOL bExitFired=FALSE;
              BOOL bShowMsgBox=FALSE;
  
            int peed = GetWindowTextLength(GetDlgItem(hwnd,IDE_NUMBERS));
               
            if(peed > 0) 
              {
                size_buffer = (char*)GlobalAlloc(GPTR, peed + 1);
                GetDlgItemText(hwnd, IDE_NUMBERS, size_buffer, peed + 1);
                TempNumber = atoi(size_buffer);
                
             if(TempNumber<EntryNo && TempNumber>1){
               wavCount=TempNumber-1;
               }
               else{
               MessageBox(NULL, "Sample # is out of range. ..","Caption_Editor ",
               MB_OK);
               }
                
               GlobalFree((HANDLE)size_buffer);
                }
	           }
              else{
	            MessageBeep(0);
               }
              }
	            break; 
		   
        case IDB_EXPORTS:
        	if(fileLoaded==1 && wavCount>0) {
        	read_newcaps();
            SendMessage(hNewCaptions, WM_SETTEXT,0,0);
			}	
			 else {
			 	MessageBeep(0);
			 }
        	break;
           
        case MU_LOADTPA:
        	  Load_Tpa();
        	 break;
           
        case IDB_FORWARD:
        	 if(fileLoaded==1 && wavCount<EntryNo-1)
        	  {
        	  	wavCount++;
        	  	readCaptions();
                SendMessage(hOldCaptions, WM_SETTEXT,0,0);
                SetDlgItemText(hwnd,IDE_OLDCAPS, post_Caption.c_str()); 
				
				SendMessage(hNumsEdit, WM_SETTEXT,0,0);
				std::stringstream xyz;
				xyz<<wavCount;
				std::string showCount;
				xyz>>showCount;
                SetDlgItemText(hwnd,IDE_NUMBERS, showCount.c_str()); 	
        	  }
        	   else {
        	   	MessageBeep(0);
        	   }
 
        	 break;
        	 
         case IDB_DONE:
          Caus_to_EELFile ();
          if(loadeddir==1) {
          MessageBox(NULL, "*EEL File created.  Use the Effects_Editor to load the"
		  " newly created *eel file (inside caus_out folder)"
		  " Click 'Save Pack File' to create your new tpa", "Caption_Editor", MB_ICONASTERISK);
	       }
        	 break;       	 
		
	}
   }
		/* All other messages (a lot of them) are processed using default procedures */
		default:
			return DefWindowProc(hwnd, Message, wParam, lParam);
	}
	return 0;
}
